#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
//   Important note about DLL memory management:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library BCBMM.LIB to both the DLL project and any
//   EXE projects that use the DLL.  This will change the DLL and its calling
//   EXE's to use the BCBMM.DLL as their memory manager.  In these cases,
//   the file BCBMM.DLL should be deployed along with your DLL.
//
//   To avoid using BCBMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//---------------------------------------------------------------------------
#include "mixmaster.h"
#include "qsnymver.h"
#include "nymwizdlgs.h"
#include "nymdecdlgs.h"
#include "fingerdlgs.h"
USERES("QSNYM.res");
USEFORM("NymEditDlgs.cpp", NymEditDlg);
USEFORM("NymRemsDlgs.cpp", NymRemsDlg);
USEFORM("NymRepDlgs.cpp", NymRepDlg);
USEFORM("NymDecDlgs.cpp", NymDecDlg);
USEFORM("MixmastDlg.cpp", MixForm);
USEFORM("NymWizDlgs.cpp", NymWizDlg);
USEFORM("HelpDlgs.cpp", HelpDlg);
USEFORM("View.cpp", ViewDlg);
USEUNIT("PGPbuffers.cpp");
USEUNIT("nymmail.cpp");
USEUNIT("Global.cpp");
USEUNIT("FileMan.cpp");
USEUNIT("Mixmaster.cpp");
USEUNIT("HeadMan.cpp");
USEUNIT("PgpFiles.cpp");
USEUNIT("pgpmail.cpp");
USEUNIT("QSnymVer.cpp");
USEFORM("FingerDlgs.cpp", FingerDlg);
USEFORM("NymIntrDlgs.cpp", NymIntrDlg);
USEFORM("WipeDlgs.cpp", WipeDlg);
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall NymInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, HWND AppHandle);
extern "C" __declspec(dllexport) void __fastcall NymShutDown();
extern "C" __declspec(dllexport) char*__fastcall GetNymLibVersion();
extern "C" __declspec(dllexport) char*__fastcall GetNymLibName();
extern "C" __declspec(dllexport) bool __fastcall RunNymWizard(TForm *Owner);
extern "C" __declspec(dllexport) void __fastcall RunFinger(TForm *Owner);
extern "C" __declspec(dllexport) char*__fastcall DecryptNymMessage(TForm *Owner,
   char *msg, int &errcode);
//---------------------------------------------------------------------------
char *retbuf=NULL;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
	return 1;
}
//---------------------------------------------------------------------------
void __fastcall NymInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, HWND AppHandle)
{
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
}
//---------------------------------------------------------------------------
void __fastcall NymShutDown()
{
   if (retbuf) delete retbuf;
}
//---------------------------------------------------------------------------
char*__fastcall GetNymLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
char*__fastcall GetNymLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char*__fastcall DecryptNymMessage(TForm *Owner, char *message, int &errcode)
{
   TStringList *msg = new TStringList();
   msg->SetText(message);
   if (retbuf) delete retbuf; retbuf = NULL;
   TNymDecDlg *NymDecDlg = new TNymDecDlg(Owner);
   CenterDialog(NymDecDlg,Owner);
   if (NymDecDlg->Decrypt(msg))
   {
      retbuf = new char[msg->Text.Length()+1];
      strcpy(retbuf,msg->Text.c_str());
   }
   errcode = NymDecDlg->errcode;
   delete NymDecDlg;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall RunNymWizard(TForm *Owner)
{
   bool run=false;
   NymWizDlg = new TNymWizDlg(Owner);
   CenterDialog(NymWizDlg,Owner);
   NymWizDlg->ShowModal();
   if (NymWizDlg->ModalResult==mrOk)
      run = true;
   delete NymWizDlg;
   return run;
}
//---------------------------------------------------------------------------
void __fastcall RunFinger(TForm *Owner)
{
   FingerDlg = new TFingerDlg(Owner);
   CenterDialog(FingerDlg,Owner);
   FingerDlg->ShowModal();
   delete FingerDlg;
}
//---------------------------------------------------------------------------
